/***   [whelp.c]
*
*	wvEBhE		(C)
*
*	For GNU C Compiler (GCC)   Version 1.39
*
***/

#include <mos.h>
#include "graph.h"
#include "window.h"
#include "others.h"

#define WH_CAN		1
#define WH_TITLE	2
#define WH_BACK		3
#define WH_NEXT		4
#define WH_OTHER	0

extern int	PAL_Black, PAL_Button;
static int	wx, wy;
static int	nPage = 8, Page;
const static char	*help[][8] = {
	{
	/*	"                  40                  "	*/
		"",
		"       vrs   Version 1.0",
		"",
		"",
		"                   ",
		"",
		"",
		"  Copyright (C)   Aug. 18, 1991 "
	}, {
		"Eet̃EBhE͓ʂȈ",
		"  ȂĂ܂  𑀍삵ꍇ",
		"  ĂsĂ",
		"",
		"ECh^t@CZN^𑀍쒆",
		"  c[\𒆒fꍇ",
		"  }EX̉E{^NbN",
		"                             1/7"
	}, {
		"Ex̂oblTEhɂ",
		"  Đł鉹ɌE܂",
		"",
		"EXR[vړꍇ ʍ",
		"  {^ō{^ Pbق",
		"  ҂ĂhbO {^",
		"  Ă",
		"                                     2/7"
	}, {
		"sNIvVt",
		"  \@",
		"    /tabm {0|1}        ދL̕\(0)",
		"    /crm {0|1}        sL̕\(1)",
		"    /tab {1|2|4|8}             ޒ(8)",
		"    /lg {0`4}                sԊu(2)",
		"    /lc {0|20`500}            (80)",
		"                                     3/7"
	}, {
		"  wi",
		"    /bg-tiff <̧ٖ>          TIFF̧",
		"    /bg-tile <̧ٖ> <ԍ>     ݸ",
		"    /bg-beta <Fԍ>           h",
		"",
		"  XN[",
		"    /scspd {0`4}       ۰٥߰(2)",
		"                                     4/7"
	}, {
		"  x",
		"    /wa-beep                    ް߉",
		"    /wa-pcm <̧ٖ>           pcm",
		"",
		"  t@CZN^",
		"    /fcap {0|1}       0: 1:啶",
		"    /fsort {0`3}               ĕ@",
		"                                     5/7"
	}, {
		"    /fwide {0|1}          0:W 1:ܲ",
		"",
		"  ̑",
		"    /m             IMS-DOSʂ",
		"",
		"     / ̕tȂ̂",
		"              ÷̧ٖƌȂ܂",
		"                                     6/7"
	}, {
		"s҂̈ꌾt",
		"",
		"    ̑AEv]܂",
		"    ҂܂łAB",
		"    izEoO̕񍐂Ȃǂ҂j",
		"    iĂ܂B                j",
		"",
		"                                     7/7"
	}
};

static void	Open_window(void);
static int	Where(int, int);
static void	DrawHelp(void);
static void	SUB_page(int);
static int	SUB_page_sub(int);
static void	Indicate(int, int);

void WIND_help(void) {
	int		ret = 0;
	
	wx = 152;
	wy = 142;
	{
		struct RECT	a, b;
		
		a.x1 = 319;	a.y1 = 259;
		a.x2 = 320;	a.y2 = 260;
		b.x1 = wx;	b.y1 = wy;
		b.x2 = wx + 335;	b.y2 = wy + 196;
		afterImage(&a, &b);
	}
	
	Page = 0;
	Open_window();
	while (!ret) {
		char	mb;
		int		mx, my;
		
		CLOCK(0);
		if (MOS_rdpos(&mb, &mx, &my), !(mb & 1))
			continue;
		
		switch (Where(mx, my)) {
			case WH_CAN:
				if (Button(wx + 6, wy + 6, wx + 25, wy + 25))
					ret = -1;
				break;
			
			case WH_TITLE:
				{
					struct RECT	w, s;
					
					s.x1 = 0;	s.y1 = 40;
					s.x2 = 639;	s.y2 = 463;
					w.x1 = wx;	w.y1 = wy;
					w.x2 = wx + 335;	w.y2 = wy + 196;
					if (dragWindow(mx, my, &w, &s, 0, 0)) {
						wx = w.x1;	wy = w.y1;
						MOS_disp(0);
						EGB_cls(0);
						MOS_disp(1);
						Open_window();
					}
				}
				break;
			
			case WH_BACK:	SUB_page(0);	break;
			case WH_NEXT:	SUB_page(1);	break;
			
			default:
				while (MOS_rdpos(&mb, &mx, &my), mb & 1);
				break;
		}
	}
	
	return;
}

static void Open_window(void) {
	int		a[2] = {4, 4};
	struct opnwin_t	opw;
	
	opw.title = "w  v";
	opw.x1 = wx;
	opw.y1 = wy;
	opw.x2 = opw.x1 + 335;
	opw.y2 = opw.y1 + 196;
	opw.shdw = 1;
	opw.canb = 1;
	opw.nopt = 2;
	opw.wopt = a;
	opw.expb = 0;
	opw.ord = 0;
	
	MOS_disp(0);
	drawWindow(&opw);
	Indicate(1, 1);
	DrawHelp();
	MOS_disp(1);
}

static int Where(int x, int y) {
	int		ret;
	
	x -= wx;
	y -= wy;
	if (5 < x && x < 26 && 5 < y && y < 26)
		ret = WH_CAN;
	else if (26 < x && x < 256 && 5 < y && y < 26)
		ret = WH_TITLE;
	else if (256 < x && x < 293 && 5 < y && y < 26)
		ret = WH_BACK;
	else if (293 < x && x < 330 && 5 < y && y < 26)
		ret = WH_NEXT;
	else
		ret = WH_OTHER;
	
	return ret;
}

static void Indicate(int a, int b) {
	if (a)
		EGB_str("O", wx + 259, wy + 23, Page > 0 ? PAL_Black : 7);
	if (b)
		EGB_str("", wx + 296, wy + 23, Page < nPage - 1 ? PAL_Black : 7);
}

static void DrawHelp(void) {
	int		i;
	
	EGB_boxf(wx + 8, wy + 29, wx + 327, wy + 188, 7, 7);
	for (i = 0; i < 8; i++)
		EGB_str3(help[Page][i], wx + 8, wy + 46 + i * 20, PAL_Black, 7);
}

static void SUB_page(int mode) {
	int		flpush = 1, fllast = 0;
	int		lx, ly, mx, my;
	char	mb;
	
	if (mode && Page >= nPage - 1 || !mode && Page <= 0) {
		while (MOS_rdpos(&mb, &mx, &my), mb & 1);
		return;
	}
	
	lx = wx + (mode ? 294 : 257);
	ly = wy + 6;
	
	EGB_rev(1, lx, ly, lx + 35, ly + 19);
	fllast = SUB_page_sub(mode);
	TIMER_set(30);
	while (MOS_rdpos(&mb, &mx, &my), mb & 1 && !fllast) {
		int		whres;
		
		whres = Where(mx, my) == (mode ? WH_NEXT : WH_BACK);
		if (!whres && flpush || whres && !flpush) {
			EGB_rev(1, lx, ly, lx + 35, ly + 19);
			flpush = !flpush;
		}
		
		if (flpush && TIMER())
			fllast = SUB_page_sub(mode);
	}
	
	MOS_disp(0);
	Indicate(1, 1);
	MOS_disp(1);
	if (fllast)
		while (MOS_rdpos(&mb, &mx, &my), mb & 1);
}

static int SUB_page_sub(int mode) {
	int		result = 1;
	
	if (mode && Page < nPage - 1 || !mode && Page > 0) {
		mode ? Page++ : Page--;
		MOS_disp(0);
		DrawHelp();
		Indicate(mode ? 1 : 0, mode ? 0 : 1);
		MOS_disp(1);
		result = 0;
	}
	
	return result;
}
